/*      (c) 1993-2001 Marc H.E. Vos               +
 *      Dordrecht                                 +
 *      Netherlands                               +
 *                                                +
 *      Phone: +31 6 53122183                     +
 *      Fax  : +31 78 6399494                     */

pgm parm(&src &where &prmp &objl) /* (C) 1993-2001 Marc H.E. Vos */
   dcl &src    *char 10
   dcl &where  *char 20
   dcl &prmp   *char 1
   dcl &objl   *char 10
   dcl &srcf   *char 10
   dcl &srcl   *char 10
   dcl &srct   *char 10
   dcl &srctx  *char 50

   dcl &ofil    *char 10
   dcl &ok      *char 1

   dcl &loglvl  *char 1
   dcl &logsev  *dec (2 0)
   dcl &logcl   *char 10
   dcl &stsmsg  *char 7
   dcl &wrkstn  *char 10

   dcl &text   *char 60
   dcl &msgt   *char 132
   dcl &blanks *char 132

/* Don't show CL-commands */
   rtvjoba job(&wrkstn) loglvl(&loglvl)  logsev(&logsev) +
                        logclpgm(&logcl) stsmsg(&stsmsg)
   chgjob log(0 99) logclpgm(*no) stsmsg(*none)

   chgvar &msgt ('Expanded source for ' *cat &src *tcat ' not created.')

/* Check library/file */
   chgvar &srcf (%sst(&where 01 10))
   chgvar &srcl (%sst(&where 11 10))

   chkobj obj(&srcl/&srcf) objtype(*file) mbr(&src) aut(*read)
   monmsg cpf0000 exec(goto Einde)

/* Get source type */
   rtvmbrd file(&srcl/&srcf) mbr(&src) srctype(&srct) text(&srctx)

   chgvar &ofil ('E$XP')
   chgvar %sst(&ofil 5 6) (&srct)

/* Check output sourcefile */
   chkobj obj(&srcl/&ofil) objtype(*file)
   monmsg cpf0000 exec(do)
      chgvar &text ('E$EXP * Expanded ' *cat &srct *tcat ' sources.')
      crtsrcpf file(&srcl/&ofil) text(&text)
      monmsg cpf0000 exec(goto Einde)
   enddo

/* Create workfiles */
   dltf qtemp/orgsrc
   monmsg cpf0000
   crtpf qtemp/org rcdlen(80) size(*nomax) maxmbrs(*nomax)
   monmsg cpf0000 exec(goto Einde)
   rnmobj qtemp/org *file orgsrc

   chkobj obj(QTEMP/NEWSRC) objtype(*file)
   monmsg cpf0000 exec(do)
      crtpf qtemp/newsrc e$exp/src size(*nomax)
      monmsg cpf0000 exec(goto Einde)
   enddo
   clrpfm qtemp/newsrc

   chkobj obj(QTEMP/CVTSRC) objtype(*file)
   monmsg cpf0000 exec(do)
      crtpf qtemp/cvt rcdlen(80) size(*nomax)
      monmsg cpf0000 exec(goto Einde)
      rnmobj qtemp/cvt *file cvtsrc
   enddo
   clrpfm qtemp/cvtsrc

   chkobj obj(QTEMP/CHKSRC) objtype(*file)
   monmsg cpf0000 exec(do)
      crtpf qtemp/chksrc e$exp/src size(*nomax)
      monmsg cpf0000 exec(goto Einde)
   enddo
   clrpfm qtemp/chksrc

/* Copy orginal source to &OFIL */
   cpysrcf fromfile(&srcl/&srcf) tofile(&srcl/&ofil) +
        frommbr(&src) tombr(&src) mbropt(*REPLACE)
   monmsg cpf0000 exec(goto Einde)
   clrpfm &srcl/&ofil mbr(&src)
   chgpfm &srcl/&ofil mbr(&src) text(&srctx)

/* Copy orginal source to workfile */
   cpyf fromfile(&srcl/&srcf) tofile(QTEMP/ORGSRC) +
        frommbr(&src) tombr(&src) mbropt(*REPLACE) fmtopt(*CVTSRC)
   monmsg cpf0000 exec(goto Einde)

/* Set pointer to new member */
   ovrdbf file(orgsrc) mbr(&src)

   chgvar &ok ('Y')
   call E$EXP02  parm(&srcl &srcf &srct)
   monmsg cpf0000 exec(chgvar &ok ('N'))

   dltovr file(orgsrc)

   if (&ok *ne 'Y') goto Einde

/* Copy new source to &OFIL */
   call E$EXP05
   monmsg cpf0000 exec(goto Einde)
   cpyf fromfile(qtemp/cvtsrc) tofile(&srcl/&ofil) +
        frommbr(*first) tombr(&src) mbropt(*ADD) fmtopt(*CVTSRC)
   monmsg cpf0000 exec(goto Einde)
   chgvar &msgt ('Expanded source for ' *cat &src *tcat +
                 ' created in source file ' *cat &srcl *tcat +
                 '/' *cat &ofil *tcat '.')

   if (&prmp *ne 'Y') goto Einde /* No CRT* prompt */

   if (&srct *eq 'CLP') do
             ?          CRTCLPGM ??PGM(&OBJL/&SRC) +
                          SRCFILE(&SRCL/&OFIL) ??LOG(*NO) +
                          ??ALWRTVSRC(*NO) ??REPLACE(*YES)
             monmsg cpf0000 exec(goto Einde)
   enddo
   else if (&srct *eq 'PF') do
             ?          CRTPF ??FILE(&OBJL/&SRC) +
                          SRCFILE(&SRCL/&OFIL) ??MAXMBRS(*NOMAX) +
                          ??SIZE(*NOMAX) ??WAITRCD(5)
             monmsg cpf0000 exec(goto Einde)
   enddo
   else if (&srct *eq 'LF') do
             ?          CRTLF ??FILE(&OBJL/&SRC) +
                          SRCFILE(&SRCL/&OFIL) ??MAXMBRS(*NOMAX) +
                          ??WAITRCD(5)
             monmsg cpf0000 exec(goto Einde)
   enddo
   else if (&srct *eq 'RPG') do
             ?          CRTRPGPGM ??PGM(&OBJL/&SRC) +
                          SRCFILE(&SRCL/&OFIL) ??REPLACE(*YES)
             monmsg qrg9000 exec(do)
                SNDPGMMSG  MSGID(QRG9001) MSGF(QRPG/QRPGMSG) +
                           topgmq(*prv)
             enddo
             monmsg cpf0000 exec(goto Einde)
   enddo
   else if (&srct *eq 'CMD') do
             ?          CRTCMD ??CMD(&OBJL/&SRC) ??PGM(&SRCL/&SRC) +
                          SRCFILE(&SRCL/&OFIL) ??VLDCKR(*NONE) +
                          ??ALLOW(*ALL) ??PMTFILE(*NONE) +
                          ??HLPPNLGRP(*NONE) ??HLPID(*NONE) +
                          ??PRDLIB(*NOCHG) ??REPLACE(*YES)
             monmsg cpf0000 exec(goto Einde)
   enddo
   else if (&srct *eq 'DSPF') do
             ?          CRTDSPF ??FILE(&OBJL/&SRC) +
                          SRCFILE(&SRCL/&OFIL) ??RSTDSP(*YES) +
                          ??LVLCHK(*YES) ??REPLACE(*YES)
             monmsg cpf0000 exec(goto Einde)
   enddo
   else if (&srct *eq 'PRTF') do
             ?          CRTPRTF ??FILE(&OBJL/&SRC) +
                          SRCFILE(&SRCL/&OFIL) ??PAGESIZE(72) +
                          LPI(6) ??CPI(10) OVRFLW(72) +
                          ??PRTQLTY(*STD) ??MAXRCDS(*NOMAX) +
                          ??HOLD(*NO) ??SAVE(*NO) ??USRDTA(*SOURCE) +
                          ??LVLCHK(*YES) ??REPLACE(*YES)
             monmsg cpf0000 exec(goto Einde)
   enddo

Einde:
   sndpgmmsg msg(&msgt) topgmq(*prv)
   chgjob log(&loglvl &logsev) logclpgm(&logcl) stsmsg(&stsmsg)
Quit:
endpgm
